/*
 * Ubiquity REST API
 * Ubiquity provides a RESTful and uniform way to access blockchain resources, with a rich and reusable model across multiple cryptocurrencies.  [Documentation](https://app.blockdaemon.com/docs/ubiquity)  ##### Pagination Certain resources contain a lot of data, more than what's practical to return for a single request. With the help of pagination, the data is split across multiple responses. Each response returns a subset of the items requested and a continuation token.  To get the next batch of items, copy the returned continuation token to the continuation query parameter and repeat the request with the new URL. In case no continuation token is returned, there is no more data available. 
 *
 * The version of the OpenAPI document: 2.0.0
 * Contact: support@blockdaemon.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

package com.gitlab.blockdaemon.ubiquity.example;

import java.util.Map;

import com.gitlab.blockdaemon.ubiquity.UbiquityClient;
import com.gitlab.blockdaemon.ubiquity.UbiquityClientBuilder;
import com.gitlab.blockdaemon.ubiquity.model.Block;
import com.gitlab.blockdaemon.ubiquity.model.MultiTransferOperation;
import com.gitlab.blockdaemon.ubiquity.model.Network;
import com.gitlab.blockdaemon.ubiquity.model.Operation;
import com.gitlab.blockdaemon.ubiquity.model.Order;
import com.gitlab.blockdaemon.ubiquity.model.Platform;
import com.gitlab.blockdaemon.ubiquity.model.PlatformDetail;
import com.gitlab.blockdaemon.ubiquity.model.Tx;
import com.gitlab.blockdaemon.ubiquity.model.TxPage;

public class UbiquityClientExample {

	private static final String ETH_ACCOUNT = "0xC02aaA39b223FE8D0A0e5C4F27eAD9083C756Cc2";
	private static final String ETH_TX_ID = "0x6821b32162ad40f979ad8e999ffbe358e5df0f54e1894d1b3fc3e01fce6a134b";
	private static final String ALGO_ACCOUNT = "HG2JL36OPPITBA7RNIPW4GUQS74AF3SEBO6DAJSLJC33C34I2DQ42F5MU4";

	public static void main(String... args) throws Exception {

		String authBearerToken = System.getenv("AUTH_TOKEN");

		UbiquityClient client = new UbiquityClientBuilder().authBearerToken(authBearerToken).build();

		PlatformDetail details = client.platform().getPlatform(Platform.BITCOIN, Network.MAIN_NET);
		System.out.println(details);

		Long height = client.sync().currentBlockNumber(Platform.BITCOIN, Network.MAIN_NET);
		System.out.println(height);

		String id = client.sync().currentBlockID(Platform.BITCOIN, Network.MAIN_NET);
		System.out.println(id);

		// New protocols or networks may not be present in the client but can be
		// accessed via the name method
		Block block = client.block().getBlock(Platform.name("bitcoin"), Network.name("mainnet"), 685700);
		System.out.println(block);

		// Operation is a wrapper for various different types in this case a MultiTransferOperation
		Operation operation = block.getTxs().get(0).getOperations().get("script");
		MultiTransferOperation multiTransferOperation = operation.getMultiTransferOperation();
		System.out.println(multiTransferOperation);

		// If you are unsure of which type to expect the getActualInstance returns the instance as an object which can then be type checked
		Object unkownOperation = operation.getActualInstance();
		if(unkownOperation instanceof MultiTransferOperation) {
			System.out.println("MultiTransferOperation");
		}
		
		Block currentBlock = client.block().getBlock(Platform.ETHEREUM, Network.MAIN_NET, "current");
		System.out.println(currentBlock);

		Map<String, Object> balances = client.accounts().getBalancesByAddress(Platform.ALGORAND,
				Network.name("mainnet"), ALGO_ACCOUNT);
		System.out.println(balances);

		Tx tx = client.transactions().getTx(Platform.name("ethereum"), Network.name("mainnet"), ETH_TX_ID);
		System.out.println(tx);

		TxPage accountTxPage = client.accounts().getTxsByAddress(Platform.ETHEREUM, Network.MAIN_NET, ETH_ACCOUNT);
		System.out.println(accountTxPage);

		// Initial request to paged API's should not include a continuation.
		// If no limit is supplied the default of 25 will be applied
		// A filter can also be applied to select the returned assets
		TxPage txPage1 = client.transactions().getTxs(Platform.ETHEREUM, Network.MAIN_NET, Order.DESC, "", null, null);
		System.out.println(txPage1);

		// To continue through the pages of transactions the continuation from the
		// previous page must be supplied to the next request
		String previous = txPage1.getContinuation();
		TxPage txPage2 = client.transactions().getTxs(Platform.ETHEREUM, Network.MAIN_NET, Order.DESC, previous);
		System.out.println(txPage2);

	}
}
